/*
 * Copyright (c) 1993  Kenji Arisawa. All right reserved.
 * License to freely use and distribute this software is hereby granted 
 * by the author, subject to the condition that this copyright notice 
 * remains intact.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES.
 */
#ifndef lint
static char sccsid[] = "@(#)speed.c	1.0 (Kenar) 2/3/96";
#endif /* not lint */

#include <sys/ioctl.h>

/*
 *	Baud rate mapping table
 *	- Kenar -
 *	1996/03: T.kuwahara <taka@syc.toppan.co.jp> modified for SunOS4.1.X
 */
typedef struct baudmap
{	char *name;
	int br;
	int bc;
} BAUD;
static BAUD bmap[] = 
#if defined(NeXT)
{	/* see <sys/ttydev.h> for NeXT. - Kenar - */
	"0",	0,		B0,
	"50",	50,		B50,
	"75",	75,		B75,
	"110",	110,	B110,
	"134",	134,	B134,
	"150",	150,	B150,
	"200",	200,	B200,
	"300",	300,	B300,
	"600",	600,	B600,
	"1200",	1200,	B1200,
	"2400",	2400,	B2400,
	"4800",	4800,	B4800,
	"9600",	9600,	B9600,
	"14400",	14400,	B14400,
	"19200",	19200,	B19200,
	"28800",	28800,	B28800,
	"38400",	38400,	B38400,
	"43200",	43200,	B43200,
	"57600",	57600,	B57600,
	"HUP",	0,	B0,
	"EXTA",	0,	EXTA,
	"EXTB",	0,	EXTB,
	(char*)0,	-1,		-1
};
#elif defined(SUN5)
{
	"0",	0,		B0,
	"50",	50,		B50,
	"75",	75,		B75,
	"110",	110,	B110,
	"134",	134,	B134,
	"150",	150,	B150,
	"200",	200,	B200,
	"300",	300,	B300,
	"600",	600,	B600,
	"1200",	1200,	B1200,
	"2400",	2400,	B2400,
	"4800",	4800,	B4800,
	"9600",	9600,	B9600,
	"19200",	19200,	B19200,
	"38400",	38400,	B38400,
	"HUP",	0,	B0,
	"EXTA",	0,	EXTA,
	"EXTB",	0,	EXTB,
	(char*)0,	-1,		-1
};
#else
{
	"0",	0,		B0,
	"50",	50,		B50,
	"75",	75,		B75,
	"110",	110,	B110,
	"134",	134,	B134,
	"150",	150,	B150,
	"200",	200,	B200,
	"300",	300,	B300,
	"600",	600,	B600,
	"1200",	1200,	B1200,
	"2400",	2400,	B2400,
	"4800",	4800,	B4800,
	"9600",	9600,	B9600,
#if !defined(SUNOS) /* Modified for SunOS4.1.X - T.Kuwahara - */
	"14400",	14400,	B14400,
#endif
	"19200",	19200,	B19200,
#if !defined(SUNOS) /* Modified for SunOS4.1.X - T.Kuwahara - */
	"28800",	28800,	B28800,
#endif
	"38400",	38400,	B38400,
#if !defined(SUNOS) /* Modified for SunOS4.1.X - T.Kuwahara - */
	"43200",	43200,	B43200,
	"57600",	57600,	B57600,
#endif
	"HUP",	0,	B0,
	"EXTA",	0,	EXTA,
	"EXTB",	0,	EXTB,
	(char*)0,	-1,		-1
};
#endif

/* baudstat: converts baud code to baud rate status */
/* old name is B_to_baud_rate */
char *baudstat(code)
int code;
{	/* mod by Kenar */
	int n;
	for(n=0; bmap[n].name; n++)
		if(bmap[n].bc == code)
			return(bmap[n].name);
	return("-----");
}


/* baudrate: converts baud code to baud rate */
int baudrate(code)
int code;
{	/* mod by Kenar */
	int n;
	for(n=0; bmap[n].name; n++)
		if(bmap[n].bc == code)
			return(bmap[n].br);
	return(-1);
}


/* baudcode: converts baud rate to baud code */
int baudcode(n)
int n;
{	/* Replaced by Kenar */
	int k;
	for(k = 0; bmap[k].br != -1; k++)
		if(bmap[k].br == n) return bmap[k].bc;
	return(0);
}

